#include "ultrasonic.hpp"

struct usData_t usData[2];

void us_0_isr() {
  if(digitalRead(US_RX_0_PIN) && usData[0].rxPending) {
    usData[0].pulseStart = micros();
  } else if(usData[0].rxPending) {
    usData[0].duration   = micros() - usData[0].pulseStart;
    usData[0].rxPending = 0;
    usData[0].newData   = 1;
  }
}

void us_1_isr() {
  if(digitalRead(US_RX_1_PIN) && usData[1].rxPending) {
    usData[1].pulseStart = micros();
  } else if(usData[1].rxPending) {
    usData[1].duration   = micros() - usData[1].pulseStart;
    usData[1].rxPending = 0;
    usData[1].newData   = 1;
  }
}

void us_init() {
  attachInterrupt(digitalPinToInterrupt(US_RX_0_PIN), us_0_isr, CHANGE);
  attachInterrupt(digitalPinToInterrupt(US_RX_1_PIN), us_1_isr, CHANGE);
}

void us_transmit() {
  //testing: crashes 

  noInterrupts();

  //set pin 2, 3 and 4 to output
  DDRD  |= 0b00011100;

  //pull pin 2, 3 and 4 to 5V
  //doing this seems to lead to power supply issues and the serial interface stopps working
  //further testing needed!
  PORTD |= 0b00011100;

  delayMicroseconds(2);

  //pull pin 2, 3 and 4 to GND
  PORTD &= 0b11100011;

  delayMicroseconds(5);

  //set pin 2, 3 and 4 back to input
  DDRD  &= 0b11100011;

  interrupts();

  usData[0].rxPending = 1;
  usData[1].rxPending = 1;
} 

long us_get_duration(byte sensor) {
  // check if there is new sensor data
  if(usData[sensor].newData) {
    usData[sensor].newData = 0;
    return usData[sensor].duration;
  } else {
    return usData[sensor].duration;
    //return -1;
  }
}